package be.iminds.ilabt.jfed.experimenter_gui.editor;

import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;
import be.iminds.ilabt.jfed.rspec.rspec_source.RequestRspecSource;
import javafx.beans.property.ReadOnlyObjectProperty;
import javafx.beans.property.ReadOnlyObjectWrapper;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

import javax.annotation.Nullable;
import java.io.File;

/**
 * User: twalcari
 * Date: 5/20/2015
 * Time: 09:20
 */
public class EditableRspec {

    /**
     * The file from which this Rspec has been loaded, or where it has been saved to the last time
     */
    @Nullable
    private File file = null;

    /**
     * The name of the experiment. Typically relates to the filename of the rspec
     */
    private final StringProperty name = new SimpleStringProperty();

    private final ReadOnlyObjectWrapper<RequestRspecSource> requestRspecSource = new ReadOnlyObjectWrapper<>();

    public EditableRspec(RequestRspecSource requestRspecSource, String name, File inputFile) {
        setRequestRspecSource(requestRspecSource);
        this.name.set(name);
        this.file = inputFile;
    }

    /**
     * Creates an empty editable rspec
     */
    public EditableRspec(String name) {
        setRequestRspecSource(new RequestRspecSource(new FXModelRspec("request")));
        this.name.set(name);
    }

    public File getFile() {
        return file;
    }

    public void setFile(File file) {
        assert (file != null);
        this.file = file;
    }

    public String getName() {
        return name.get();
    }

    public void setName(String name) {
        this.name.set(name);
    }

    public StringProperty nameProperty() {
        return name;
    }

    public RequestRspecSource getRequestRspecSource() {
        return requestRspecSource.get();
    }

    public ReadOnlyObjectProperty<RequestRspecSource> requestRspecSourceProperty() {
        return requestRspecSource.getReadOnlyProperty();
    }

    public void setRequestRspecSource(RequestRspecSource requestRspecSource) {
        this.requestRspecSource.set(requestRspecSource);
    }
}
